% Lezione di lab TTR  -30/10/2013- Legge di Bayes - Marco Cristani
close all;
clear all;
clc



% ---------------------------------------------------------------------------------
% Esercizio 1 - Manipolazione e analisi di gaussiane, unimodali e multivariate
% ---------------------------------------------------------------------------------


clear all;
A= normrnd(0,2,10000,2);

h1 = figure;
scatter(A(:,1),A(:,2));
axis equal

A2d = mvnrnd([0,0],[4,0;0,4],10000);
h2 = figure;
scatter(A2d(:,1),A2d(:,2));
axis equal

% Inserisco una leggera covarianza tra le variabili
A2dc = mvnrnd([0,0],[1,-sqrt(2)/2;-sqrt(2)/2,1],10000);
h2 = figure;
scatter(A2dc(:,1),A2dc(:,2));
axis equal

%[v,a]=eig(...); % che cosa risulta, senza guardare il risultato?

% ESERCIZIO: Provate con distribuzioni 3D, visualizzate

fprintf('FINE! Premi un tasto per continuare!\n')
pause
% -----------------------------------------------
% Esercizio 2 - Funzioni discriminanti lineari
% -----------------------------------------------


num_s=100;

Pw1=0.5;
Pw2=0.5;

Mu1 = 3;%
Mu2 = 0;%

sigma=1.5;

Sample_set1 =   normrnd(Mu1,sigma,num_s,1);
Sample_set2 =   normrnd(Mu2,sigma,num_s,1);

Data = [Sample_set1 ; Sample_set2];
% 
% 
% % Disegno le funzioni discriminanti per la due classi di campioni Gaussiani
% 
W1  = (1/sigma^2).*Mu1;
w10 = -(1/(2*sigma^2))*(Mu1'*Mu1) +log(Pw1);
G1 = sum(repmat(W1,1,num_s*2).*Data',1) + ones(1,num_s*2)*w10;


W2  = (1/sigma^2).*Mu2;
w20 = -(1/(2*sigma^2))*(Mu2'*Mu2) +log(Pw2);
G2 = sum(repmat(W2,1,num_s*2).*Data',1) + ones(1,num_s*2)*w20;
% 
% % Confine di decisione
W  = Mu1-Mu2;
X0 = 0.5*(Mu1+Mu2)-((sigma^2)./((Mu1-Mu2)'*(Mu1-Mu2))).*log(Pw1/Pw2).*(Mu1-Mu2);
% 
% 
h_CBayesG1D = figure; hold on;
[Ord,index_ord] = sort(Data,'ascend');
h_S1 = scatter(Sample_set1,zeros(num_s,1),10,'b');
h_S2 = scatter(Sample_set2,zeros(num_s,1),10,'r');
h_G1 = plot(Ord,G1(index_ord),'b');
h_G2 = plot(Ord,G2(index_ord),'r');
set(gcf,'name','Classificatore Bayesiano 2 classi 1D')
h_BayesG1D=line([X0;X0],[min([G1';G2']),max([G1';G2'])],'color',[0,0,0]);
%legend([h_G1;h_G2;h_BayesG1D],{'g_1(x)';'g_2(x)';'x_0'});
legend([h_S1(1);h_S2(1);h_G1;h_G2],{strcat('N1: \mu1=',num2str(Mu1),' \sigma1=',num2str(sigma));...
    strcat('N2: \mu2=',num2str(Mu2),' \sigma2=',num2str(sigma));...
    'g_1(x)';'g_2(x)'});

%provate a cambiare i parametri... e controllare come variano le funzioni discriminanti
fprintf('FINE! \n')


